%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  図9.4のOptimizerの内容を表す関数ファイル
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% プログラム9.2(func_mpc_List_9_2)とほぼ同じ。
% 違い：function名と10行目のu_k_1=u(Hp-Hw+1+1)+u(end);
%      u(end)が外乱推定値と接続されているため, 制約条件に反映される
function delta_U=func_mpc3(u)
global F F1 f Gamma g W w
global Psi Upsilon Theta xn ul delta_U0 Hp Hw Hu Epsilon options
Epsilon=u(1:Hp-Hw+1);u_k_1=u(Hp-Hw+1+1)+u(end); % +u(end)が外乱推定値
x_k=u(Hp-Hw+xn+1:Hp-Hw+xn+2);
FGammaThetaW=[F;Gamma*Theta;W]; % 式(9.14)左辺の記述
F1ufGammagw=[-F1*u_k_1+f;-Gamma*(Psi*x_k+Upsilon*u_k_1)+g;w];% 式(9.14)右辺の記述
%
delta_U=fmincon(@objfun_mpc,delta_U0,FGammaThetaW,F1ufGammagw,[],[],[],[],[],options);
%delta_U=fmincon(@objfun_mpc,delta_U0,[],[]); % 制約条件がない場合は15行目の代わりに用いる

function y=objfun_mpc(delta_U) % 目的関数の記述を行う関数
global H G_temp Epsilon
G=G_temp*Epsilon;
y=delta_U'*H*delta_U-G'*delta_U; % 目的関数